/* Replace "dll.h" with the name of your header */
#include "TrackISS.h"




//Number of inputs 
unsigned char inputs 			= 3;
//Number of outputs
unsigned char outputs 			= 6; 

//index for input variables
const unsigned char CLK    		= 0;
const unsigned char RFL    		= 1;
const unsigned char SAT			= 2;
 
//index for user variables
const unsigned char CLK_OLD    	= 0;
const unsigned char RFL_OLD   	= 1;

//Call from PROFILAB, get number of inputs 
DLLEXPORT unsigned char _stdcall NumInputs()
{
      return inputs;
}
  
//Call from ProfiLab, get number of outputs
DLLEXPORT unsigned char _stdcall NumOutputs()
{
      return outputs;
}
  

DLLEXPORT void _stdcall GetInputName(unsigned char Channel, char *Name)
{
	
      if (Channel == 0) strcpy(Name,"CLK");
      if (Channel == 1) strcpy(Name,"RFL");
      if (Channel == 2) strcpy(Name,"SAT");
}
  

DLLEXPORT void _stdcall GetOutputName(unsigned char Channel, char *Name)
{	
	if (Channel == 0) strcpy(Name, "T"); 	//tsince
	if (Channel == 1) strcpy(Name, "X"); 	//X
	if (Channel == 2) strcpy(Name, "Y"); 	//Y
	if (Channel == 3) strcpy(Name, "Z");    //Z
	if (Channel == 4) strcpy(Name, "Distance");
	if (Channel == 5) strcpy(Name, "Epoch"); 
	//if (Channel == 6) strcpy(Name, "$Out1");
}
  
//Aufruf von PROFILAB, setzt bei Programmstart den "Counter"auf "0"+ setzt alle Ausgaenge zurueck
DLLEXPORT void _stdcall CSimStart(double *PInput, double *POutput, double *PUser)
{
	/* hier wordt de init uitgevoerd */  
	//SET VARIABLES
    opsmode 	= 'i';
    typerun 	= 'c';
    typeinput 	= 'e';
    whichconst 	= wgs84;
    getgravconst( whichconst, tumin, mu, radiusearthkm, xke, j2, j3, j4, j3oj2 );
    
                                                                  
    /* Reading satellite data from Norad file "stations.txt" */
    if (readfromFile == true)
    {
       ifstream f ("stations.txt");
       string s0,s1,s2;
       for (;;)
       {
         //read line 0, name of satelite 
         getline(f, s0);
         //read line 1
         getline(f, s1);
         strncpy(longstr1,s1.c_str(),sizeof(longstr1));
         longstr1[sizeof(longstr1) - 1] = 0;
         //read line 2
         getline(f, s2);
         strncpy(longstr2,s2.c_str(),sizeof(longstr2));
         longstr2[sizeof(longstr2) - 1] = 0;
         if (s1.substr(2,5)=="42711") //found the Satellite
         {
         	break; //break the for loop and continue
		 }
         
       }
    }
    //ENTER SITE DETAILS HERE
    siteLat = 52.3651; //Epe
    siteLon =  5.9635; //Epe
    siteAlt = 30.0;    //Epe
    siteLatRad = siteLat * pi / 180.0;
    siteLonRad = siteLon * pi / 180.0;
    //INITIALIZE SATELLITE TRACKING    
    twoline2rv(longstr1, longstr2, typerun, typeinput, opsmode, whichconst, startmfe, stopmfe, deltamin, satrec );
}
  
//Call from PROFILAB, this is the actual function call DLL
//DLLEXPORT void _stdcall CCalculate(double *PInput, double *POutput, double *PUser, StringParam PStrings)
DLLEXPORT void _stdcall CCalculate(double *PInput, double *POutput, double *PUser)

{
    if (PInput[CLK] > 2.5)  //Eingang CLK high?
       {
            if (PUser[CLK_OLD] < 2.5) //steigende Flanke von CLK?
            {
            	/* hier wordt de berekening uitgevoerd */
            	jd = satrec.jdsatepoch; 
				jdC = getJulianFromUnix(time(NULL));
				tsince = (jdC - jd) * 24.0 * 60.0;
				sgp4(whichconst, satrec, tsince, ro, vo);
				teme2ecef(ro, vo, jdC, recef, vecef);
        		ijk2ll(recef, latlongh);
        		rv2azel(ro, vo, siteLatRad, siteLonRad, siteAlt, jdC, razel, razelrates);
        		/*---------------------------- Results -----------------------------------*/
        		satLat 		= latlongh[0]*180/pi;  	//Latidude sattelite (degrees)
        		satLon 		= latlongh[1]*180/pi;  	//longitude sattelite (degrees)
        		satAlt 		= latlongh[2];   		//Altitude sattelite (degrees)
        		satAz  		= fmod( razel[1]*180/pi+360.0, 360.0);  	//Azemith sattelite (degrees)
        		satEl   	= razel[2]*180/pi; 		//elevation sattelite (degrees)
        		satDist 	= razel[0];  			//Distance to sattelite (km)
				POutput[0] 	= tsince;
				POutput[1] 	= ro[0];	
				POutput[2] 	= ro[1];	
				POutput[3] 	= ro[2];
				POutput[4]  = satDist;	
				POutput[5]  = satrec.epochdays;	
            }
	   }
    PUser[CLK_OLD] = PInput[CLK]; // Wert des Eigangs CLK fr naechsten Aufruf speichern
     
	if (PInput[RFL] > 2.5)  //Eingang CLK high?
	{
		if (PUser[RFL_OLD] < 2.5) //steigende Flanke von CLK?
		{
			ifstream f ("stations.txt");
       		string s;
       		//read line 0, name of satelite 
       		getline(f, s);
       		//read line 1
       		getline(f, s);
       		strncpy(longstr1,s.c_str(),sizeof(longstr1));
       		longstr1[sizeof(longstr1) - 1] = 0;
       		//read line 2
       		getline(f, s);
       		strncpy(longstr2,s.c_str(),sizeof(longstr2));
       		longstr2[sizeof(longstr2) - 1] = 0;
		}
	}
	PUser[RFL_OLD] = PInput[RFL]; // Wert des Eigangs CLK fr naechsten Aufruf speichern 
}
  
// Call from PROFILAB, is calling at simulation stop
DLLEXPORT void _stdcall CSimStop(double *PInput, double *POutput, double *PUser)
{
//do nothing
}

int WINAPI WinMain ( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR szComdLine, int iCmdShow);  

DLLEXPORT void _stdcall CConfigure(double *PUser)
{
MessageBox(NULL,TEXT("Niets te configureren"),TEXT("Config"), MB_OK);
}


BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }

    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}
